#pragma once

#include "../../../../../Klient/Include/KSGKlientV.h"
#include <Thread.h>

using namespace Framework;

class ProzessReturn
{
public:
    virtual void prozessEnd( int aktion, bool erfolg, Array< void* > &args ) = 0;
};

class Prozess : public Thread
{
private:
    EditorKlientV *k;
    int ak;
    Array< void* > *args;
    ProzessReturn *ret;
    int ref;

public:
    // Konstruktor
    Prozess( EditorKlientV *klient, int aktion, Array< void* > *args, ProzessReturn *r );
    // Destruktor
    ~Prozess();
    // nicht constant
    void thread() override;
    // Reference Counting
    Prozess *getThis();
    Prozess *release();

private:
    void init(); // aktion = 0
    void sitzungWiederherstellen(); // aktion = 1
    void sitzungVerwerfen(); // aktion = 3

};