#ifndef Ship_H
#define Ship_H

#include <Knopf.h>
#include <Fortschritt.h>
#include "../Spieler/Spieler.h"

using namespace Framework;

class Ship
{
private:
	LRahmen *ram;
	TextFeld *spieler;
	TextFeld *stabilitt;
	TextFeld *energie;
	FBalken *stabilittB;
	FBalken *energieB;
	TextFeld *reparatur;
	TextFeld *akkuLeistung;
	TextFeld *wendigkeit;
	TextFeld *beschleunigung;
	TextFeld *laserIntensitt;
	TextFeld *laserEffizienz;
	TextFeld *laserTempo;
	TextFeld *netzwerk;
	Knopf *stabilittSkill;
	Knopf *energieSkill;
	Knopf *reparaturSkill;
	Knopf *akkuLeistungSkill;
	Knopf *wendigkeitSkill;
	Knopf *beschleunigungSkill;
	Knopf *laserIntensittSkill;
	Knopf *laserEffizienzSkill;
	Knopf *laserTempoSkill;
	Knopf *netzwerkSkill;
	int ref;

public:
	// Konstruktor
	Ship( Schrift *zSchrift );
	// Destruktor
	~Ship();
	// nicht constant
	void update( Spieler *zSpieler );
	int doMausEreignis( MausEreignis &me );
	bool tick( double tickVal );
	void render( Bild &zRObj );
	// Reference Counting
	Ship *getThis();
	Ship *release();
};

#endif